//-------------------------------------------------------------------------
/*
Copyright (C) 2005 - Justin Marshall

This file is part of the blood reconstruction project.

WinBlood is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//-------------------------------------------------------------------------

// common.cpp

#include "game.h"

/*
=========================================================
boolean jCommon::PicInView(short tile_num, BOOL reset)
=========================================================
*/

boolean jCommon::PicInView(short tile_num, BOOL reset)
{
	if (TEST(build_func->build_gotpic(tile_num >> 3), 1 << (tile_num & 7)))
    {
       if (reset)
           build_func->build_resetgotpic(tile_num);
            
      return (TRUE);
    }

    return (FALSE);
}

/*
==========================================
int jCommon::spriteSeePlayer(int spriteNum)

Info:
Determines if sprite is in visual range of 
player 0.
==========================================
*/

int jCommon::spriteSeePlayer(int spriteNum)
{
	spritetype    *thisSprite = build_func->Game_GetSprite(spriteNum);
	bloodPlayer_t *thisPlayer = thisGame->gamePlayers.at(0);

	return build_func->cansee(thisPlayer->posx,thisPlayer->posy,thisPlayer->posz,thisPlayer->sectorNum,
							  thisSprite->x,thisSprite->y,thisSprite->z,thisSprite->sectnum);
}
