//-------------------------------------------------------------------------
/*
Copyright (C) 2005 - Justin Marshall

This file is part of the blood reconstruction project.

WinBlood is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
//-------------------------------------------------------------------------

// console.cpp

#include "game.h"

console_t::console_t()
{
	bktexture = 1120;
	drawy     = 0;
}

/*
=======================================
void console_t::Con_Printf(char *txt)
=======================================
*/

void console_t::Con_Printf(char *txt)
{
	consoleTxt.push_back(txt);
}

/*
=====================================================
void console_t::DrawString(char *txt, int x, int y)
=====================================================
*/

void console_t::DrawString(char *txt, int x, int y)
{
	//guimanager->Blood_Printf(txt,4417,4400,5,6,x,y);

}

/*
===================================
void console_t::HandleInput(void)
===================================
*/

void console_t::HandleInput(void)
{
	if(inputstr.size() > 0)
		DrawString((char *)inputstr.c_str(),20,drawy-35);

	if(inputstr.size() < 15)
	{
		if(build_func->build_KeyDown(sc_0))
			inputstr.append("0");
		if(build_func->build_KeyDown(sc_1))
			inputstr.append("1");
		if(build_func->build_KeyDown(sc_2))
			inputstr.append("2");
		if(build_func->build_KeyDown(sc_3))
			inputstr.append("3");
		if(build_func->build_KeyDown(sc_4))
			inputstr.append("4");
		if(build_func->build_KeyDown(sc_5))
			inputstr.append("5");
		if(build_func->build_KeyDown(sc_6))
			inputstr.append("6");
		if(build_func->build_KeyDown(sc_7))
			inputstr.append("7");
		if(build_func->build_KeyDown(sc_8))
			inputstr.append("8");
		if(build_func->build_KeyDown(sc_9))
			inputstr.append("9");

		if(build_func->build_KeyDown(sc_A))
			inputstr.append("a");
		if(build_func->build_KeyDown(sc_B))
			inputstr.append("b");
		if(build_func->build_KeyDown(sc_C))
			inputstr.append("c");
		if(build_func->build_KeyDown(sc_D))
			inputstr.append("d");
		if(build_func->build_KeyDown(sc_E))
			inputstr.append("e");
		if(build_func->build_KeyDown(sc_F))
			inputstr.append("f");
		if(build_func->build_KeyDown(sc_G))
			inputstr.append("g");
		if(build_func->build_KeyDown(sc_H))
			inputstr.append("h");
		if(build_func->build_KeyDown(sc_I))
			inputstr.append("i");
		if(build_func->build_KeyDown(sc_J))
			inputstr.append("j");
		if(build_func->build_KeyDown(sc_K))
			inputstr.append("k");
		if(build_func->build_KeyDown(sc_L))
			inputstr.append("l");
		if(build_func->build_KeyDown(sc_M))
			inputstr.append("m");
		if(build_func->build_KeyDown(sc_N))
			inputstr.append("n");
		if(build_func->build_KeyDown(sc_O))
			inputstr.append("o");
		if(build_func->build_KeyDown(sc_P))
			inputstr.append("p");
		if(build_func->build_KeyDown(sc_Q))
			inputstr.append("q");
		if(build_func->build_KeyDown(sc_R))
			inputstr.append("r");
		if(build_func->build_KeyDown(sc_S))
			inputstr.append("s");
		if(build_func->build_KeyDown(sc_T))
			inputstr.append("t");
		if(build_func->build_KeyDown(sc_U))
			inputstr.append("u");
		if(build_func->build_KeyDown(sc_V))
			inputstr.append("v");
		if(build_func->build_KeyDown(sc_W))
			inputstr.append("w");
		if(build_func->build_KeyDown(sc_X))
			inputstr.append("x");
		if(build_func->build_KeyDown(sc_Y))
			inputstr.append("y");
		if(build_func->build_KeyDown(sc_Z))
			inputstr.append("z");
		if(build_func->build_KeyDown(sc_Space))
			inputstr.append(" ");
	}

	if(build_func->build_KeyDown(sc_BackSpace) && inputstr.size() > 0)
		inputstr.erase(inputstr.end());
	if(build_func->build_KeyDown(sc_Enter))
		inputstr.clear();

	build_func->KBClearLastScanCode();
}

/*
====================================
void console_t::DrawConsole(int y)
====================================
*/

void console_t::DrawConsole(int y)
{
	int numrows = (800 / 64) + 1;
	int numcols = (600 / 64) + 1;

	drawy = y;
	// Tile the console background
	for(int i = 0; i < numrows; i++)
	{
		for(int j = 0; j < numcols; j++)
		{
			build_func->rotatesprite(((i * 110)+0)<<15,y - (110 * j)<<15,65536L,0,bktexture + ((6+(build_func->ftotalclock()>>3))%7),0,0,1+2+8+64,0,0,800-1,600-1);
		}
	}

	DrawString("winblood",250,y-35);

	HandleInput();
}