//-------------------------------------------------------------------------
/*
Copyright (C) 2005 - Justin Marshall

This file is part of the blood reconstruction project.

WinBlood is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//-------------------------------------------------------------------------

// game_player.cpp

#include "game.h"

/*
============================================================================
void Game::PlayerFireWeapon(int projectileTile, int damage, int explosion, int range,int deathspawn)

Info:
Gets called from script.  Handles damage, protiles, etc
============================================================================
*/

void Game::PlayerFireWeapon(int projectileTile, int damage, int explosion, int range,int deathspawn)
{
	bloodPlayer_t *thisPlayer = gamePlayers.at(0);
	spritetype    *thisSprite;
	sectortype    *thisSector;
	jprojectTile  *newProjectile = new jprojectTile;
	short sect=0, hitsect=0, hitspr=0, hitwall=0;
	long zvel=0,  hitx=0,    hity=0,   hitz=0;
	int tileNum = projectileTile;
	long cosa, sina;
	long newProjectileNum=0;

	if(forcedProjWidth == 0)
		forcedProjWidth = 64;
	if(forcedProjHeight == 0)
		forcedProjHeight = 64;

	sina = (sin((long double)thisPlayer->ang * (3.141592/1024)) * 16383);
	cosa = (cos((long double)thisPlayer->ang * (3.141592/1024)) * 16383);

	if(damage <= 0)
	{
		printf("WARNING: PlayerFireWeapon damage is <= 0\n");
		return;
	}

	if(range == -1) // close range
	{

	}
	else if(projectileTile == -1)
	{
		//zvel = ((100-40)*2000) + ((build_func->krand()-32768)>>1);
		zvel = (100-48-3)*32;

		build_func->hitscan(thisPlayer->posx,thisPlayer->posy,thisPlayer->posz,thisPlayer->sectorNum,
                cosa,
                sina,
                zvel,&hitsect,&hitwall,&hitspr,&hitx,&hity,&hitz,CLIPMASK1);


		thisSprite = build_func->Game_GetSprite(hitspr);
		
		for(int i = 0; i < gameSprites.size(); i++)
		{
			if(gameSprites.at(i)->spriteNum == hitspr)
			{
				if(deathspawn != -1)
				{
					thisSector = build_func->GetSector(thisSprite->sectnum);
					build_func->spawnsprite(0, thisSprite->x,thisSprite->y, thisSector->floorz,2,0,0,32,31,47,0,0,deathspawn,thisSprite->ang,
										    0,0,0,thisSprite->sectnum+4096,thisSprite->sectnum,4,63,0,0);					                    

				}
				switch(projectileTile)
				{
					case 1:
						gameSprites.at(i)->health = -800;
					break;

					default:
					{
						gameSprites.at(i)->health -= damage;
						gameSprites.at(i)->pain   =  1;
					}
				}
			}
		}

//		printf("We hit this %d with pic %d\n",hitspr,thisSprite->picnum);
	}
	else // fire a projectile
	{
		newProjectileNum = build_func->spawnsprite(0, thisPlayer->posx,thisPlayer->posy, thisPlayer->posz+2500,2,0,0,32,forcedProjWidth,forcedProjHeight,0,0,projectileTile,thisPlayer->ang,
										0,0,0,thisPlayer->sectorNum+4096,thisPlayer->sectorNum,4,63,0,0);					                    

		newProjectile->damage    = damage;
		newProjectile->lastpic   = projectileTile;
		newProjectile->spritenum = newProjectileNum;
		newProjectile->explosion = explosion;
		activeProjectiles.push_back(newProjectile);
		//if(newProjectileNum >= numofsprites)
		//	numofsprites++;
	}
	forcedProjWidth  = 0;
	forcedProjHeight = 0;
}

/*
===================================
void Game::P_HandleMovement(void)

Manual sintable lookup
===================================
*/

void Game::P_HandleMovement(void)
{
	int turnamount = 10;
	int keymove = NORMALKEYMOVE;
	long momx=0,momy=0;
	long fvel=0, svel=0, avel=0, mesos, friendsos;
	long globhiz=0, globhihit=0, globloz=0,globlohit=0;
	long goalz;
	sectortype *playerSector;
	long cosa,sina;

	bloodPlayer_t *thisPlayer = gamePlayers.at(0); // client movement only happens with 0 player(you).

	if(this->ingame == FALSE)
		return;

	if(thisPlayer->health <= 0) // dead people can't move
	{
		if (build_func->build_KeyDown(sc_A))
			thisPlayer->ang-=turnamount;

		if (build_func->build_KeyDown(sc_D))
			thisPlayer->ang+=turnamount;

		build_func->clipmove(&thisPlayer->posx,&thisPlayer->posy,&thisPlayer->posz,&thisPlayer->sectorNum,0,0,128L,4<<8,4<<8,CLIPMASK0);
		return;
	}
	if (!build_func->build_KeyDown(sc_LeftAlt))
	{
		if (build_func->build_KeyDown(sc_A)) thisPlayer->avel-= turnamount;
		if (build_func->build_KeyDown(sc_D)) thisPlayer->avel+= turnamount;
	}
	else
	{
		if (build_func->build_KeyDown(sc_A)) thisPlayer->avel -= PREAMBLETURN;
		if (build_func->build_KeyDown(sc_D)) thisPlayer->avel += PREAMBLETURN;
	}

	// Jumping
	if(jumpingtics > 0.0f)
	{
		if(jumpingtics >= 15.0f)
			jumpturn = 0;
		if(jumpturn == 0)
		{
			jumpingtics -= 2.0f;
			thisPlayer->posz += 1600;
		}
		else
		{
			jumpingtics += 2.0f;
			thisPlayer->posz -= 1600;
		}
	}


	if(build_func->build_KeyDown(sc_Space))
	{
		if(jumpingtics <= 0)
		{
			soundManager->soundPlay(3);
			jumpingtics = 1;
			jumpturn    = 1;
			build_func->build_ClearKey(sc_Space);
		}
	}

	if(build_func->build_KeyDown(sc_Y))
	{
		switch(noclip)
		{
			case TRUE:
				noclip = FALSE;
			break;
			case FALSE:
				noclip = TRUE;
			break;
		}
		build_func->build_ClearKey(sc_Y);
	}

	// Standard movement
	if (build_func->build_KeyDown(sc_W)) // FORWARD
	{
		fvel += keymove;
	}

	if (build_func->build_KeyDown(sc_S)) // BACK
	{
			fvel += -keymove;
	}

	if (build_func->build_KeyDown(sc_V)) // SIDESTEP LEFT
	{
			svel += keymove;
	}

	if (build_func->build_KeyDown(sc_B)) // SIDESTEP RIGHT
	{
			svel += keymove;
	}

	
	if (build_func->build_KeyDown(sc_A))
		thisPlayer->ang-=turnamount;

	if (build_func->build_KeyDown(sc_D))
		thisPlayer->ang+=turnamount;

	if (build_func->build_KeyDown(sc_LeftShift))
		fvel *= 2;
	if(fvel < -MAXVEL) fvel = -MAXVEL;
	if(fvel > MAXVEL) fvel = MAXVEL;
	if(svel < -MAXSVEL) svel = -MAXSVEL;
	if(svel > MAXSVEL) svel = MAXSVEL;
	if(avel < -MAXANGVEL) thisPlayer->avel = -MAXANGVEL;
	if(avel > MAXANGVEL) thisPlayer->avel = MAXANGVEL;
	// if(horiz < -MAXHORIZ) horiz = -MAXHORIZ;
	// if(horiz > MAXHORIZ) horiz = MAXHORIZ;

	//printf("%d\n",thisPlayer->svel);

	if(svel <= 0)
		svel = min(1+2*40,0);

	if (fvel < 0) fvel = min(fvel+2*TICSPERFRAME,0);
	if (fvel > 0) fvel = max(fvel-2*TICSPERFRAME,0);

    momx = mulscale9(fvel,build_func->sintable[(thisPlayer->ang+2560)&2047]);
    momy = mulscale9(fvel,build_func->sintable[(thisPlayer->ang+2048)&2047]);
	

	if(thisPlayer->ang <= 0)
	{
		thisPlayer->ang = 2048;
	}
	else if(thisPlayer->ang >= 2048)
	{
		thisPlayer->ang = 0;
	}
	

	if(fvel != 0)
	{
		/*
		momx += ((((long)fvel)*40*(long)build_func->sintable[(thisPlayer->ang+512)&2047])>>3);
		momy += ((((long)fvel)*40*(long)build_func->sintable[thisPlayer->ang&2047])>>3);
		*/

		sina = (sin((long double)thisPlayer->ang * (3.141592/1024)) * 16383);
		cosa = (cos((long double)thisPlayer->ang * (3.141592/1024)) * 16383);

		momx += ((((long)fvel)*26*cosa)>>3);
		momy += ((((long)fvel)*26*sina)>>3);
	}

	if(svel != 0)
	{
		sina = (sin((long double)thisPlayer->ang * (3.141592/1024)) * 16383);
		cosa = (cos((long double)thisPlayer->ang * (3.141592/1024)) * 16383);

		momx += ((((long)svel)*26*cosa)>>3);
		momy += ((((long)svel)*26*sina)>>3);
	}

	//printf("momx = %d and momy =%d ang = %d\n",momx, momy,thisPlayer->ang);

	thisPlayer->oldx = thisPlayer->posx;
	thisPlayer->oldy = thisPlayer->posy;
	thisPlayer->oldz = thisPlayer->posz;
	if(noclip == FALSE)
	{
		build_func->clipmove(&thisPlayer->posx,&thisPlayer->posy,&thisPlayer->posz,&thisPlayer->sectorNum,momx,momy,128L,4<<8,4<<8,CLIPMASK0);
	}
	else
	{
		build_func->clipmove(&thisPlayer->posx,&thisPlayer->posy,&thisPlayer->posz,&thisPlayer->sectorNum,momx,momy,128L,4<<8,4<<8,0);
	}
#ifndef FAFTEST
	// Ability to move through the sos.  If the player z is less then or equal
	// to cieling then he moves to the friend sector.  If he is greater then
	// or equal to the floorz of friend sector, he is in there.
	playerSector = build_func->GetSector(thisPlayer->sectorNum);
	mesos        = sectorManager->findSosMe(thisPlayer->sectorNum);
	friendsos    = sectorManager->findSosFriendSect(thisPlayer->sectorNum);
	if(mesos > -1 && friendsos > -1)
	{
		if(thisPlayer->posz < playerSector->ceilingz)
		{
			spritetype *friendsprite, *mesprite;
			// attempt to move the player
			friendsprite = build_func->Game_GetSprite(friendsos);//sectorManager->findSosFriendSect(thisPlayer->sectorNum));
			mesprite     = build_func->Game_GetSprite(mesos);
			thisPlayer->posx = friendsprite->x - abs((thisPlayer->posx - mesprite->x));
			thisPlayer->posy = friendsprite->y - abs((thisPlayer->posy - mesprite->y));
			thisPlayer->posz = friendsprite->z;
			thisPlayer->sectorNum = friendsprite->sectnum;
		}
		else if(thisPlayer->posz > playerSector->floorz)
		{
			spritetype *friendsprite, *mesprite;
			// attempt to move the player
			friendsprite = build_func->Game_GetSprite(friendsos);//sectorManager->findSosFriendSect(thisPlayer->sectorNum));
			mesprite     = build_func->Game_GetSprite(mesos);
			thisPlayer->posx = friendsprite->x - abs((thisPlayer->posx - mesprite->x));
			thisPlayer->posy = friendsprite->y - abs((thisPlayer->posy - mesprite->y));
			thisPlayer->posz = friendsprite->z;
			thisPlayer->sectorNum = friendsprite->sectnum;
		}
	}
#endif
	gamePlayers.at(0) = thisPlayer; 
		
	// Handle Z movement
	build_func->getzrange(thisPlayer->posx,thisPlayer->posy,thisPlayer->posz,thisPlayer->sectorNum,&globhiz,&globhihit,&globloz,&globlohit,128L,CLIPMASK0);

	// player is falling?
#if 0
	if (thisPlayer->posz < globloz-(4<<8))
	{
		goalz = thisPlayer->posz - 30;
	}
	else // If player is not falling, then just move around floor obstacles(stairs, etc).
	{
		goalz = globloz-15000;
	}
#else
	goalz = globloz-15000;
#endif

	if(build_func->build_KeyDown(sc_G))
	{
		thisPlayer->posz -= 200;
	}
	else if(build_func->build_KeyDown(sc_H))
	{
		thisPlayer->posz += 200;
	}
	else
	{
		if(noclip == FALSE && jumpingtics <= 0.0f)
			thisPlayer->posz = goalz;
	}
	// Instant death, either stuck in a wall, or under crusher
	if(build_func->pushmove(&thisPlayer->posx,&thisPlayer->posy,&thisPlayer->posz,&thisPlayer->sectorNum,128L,(4L<<8),(20L<<8),CLIPMASK0)==-1)
		gamePlayers.at(0)->health = -1000;
}
